#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
/***************************************************************************
 travaux
                                 A QGIS plugin
 travaux
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2022-08-22
        git sha              : $Format:%H$
        copyright            : (C) 2022 by colas
        email                : colas.geier@cen-isere.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
from qgis.PyQt.QtCore import QSettings, QTranslator, QCoreApplication
from qgis.PyQt.QtGui import QIcon
from qgis.PyQt.QtWidgets import QAction, QMessageBox
from qgis.core import QgsWkbTypes

# Initialize Qt resources from file resources.py
from .resources import *
# Import the code for the dialog
from .travaux_dialog import travauxDialog
import os.path
import psycopg2
from datetime import datetime as dt


class travaux:
    """QGIS Plugin Implementation."""

    def __init__(self, iface):
        """Constructor.

        :param iface: An interface instance that will be passed to this class
            which provides the hook by which you can manipulate the QGIS
            application at run time.
        :type iface: QgsInterface
        """
        # Save reference to the QGIS interface
        self.iface = iface
        self.canvas = self.iface.mapCanvas()
        self.activeCouche = self.iface.activeLayer()
        # self.layer = self.iface.activeLayer()
        # self.provider = self.layer.dataProvider()
        # self.source_postgis = self.provider.dataSourceUri().replace('"', '')
        # self.flag = False
        # if self.iface.activeLayer().dataProvider().dataSourceUri():
        #     self.flag = True

        # initialize plugin directory
        self.plugin_dir = os.path.dirname(__file__)
        # initialize locale
        locale = QSettings().value('locale/userLocale')[0:2]
        locale_path = os.path.join(
            self.plugin_dir,
            'i18n',
            'travaux_{}.qm'.format(locale))

        if os.path.exists(locale_path):
            self.translator = QTranslator()
            self.translator.load(locale_path)
            QCoreApplication.installTranslator(self.translator)

        # Declare instance attributes
        self.actions = []
        self.menu = self.tr(u'&travaux')

        # Check if plugin was started the first time in current QGIS session
        # Must be set in initGui() to survive plugin reloads
        self.first_start = None
        

        self.canvas.selectionChanged.connect(self.toggle)
        self.iface.layerTreeView().currentLayerChanged.connect(self.toggle)
      


    def toggle(self):
        self.activeCouche = self.iface.activeLayer()
        if self.activeCouche:
            layer = self.activeCouche.dataProvider().dataSourceUri(True).replace('"', '')

            if ('bd-cen-38' in layer)&('table=travaux.cr' in layer):
                self.actions[0].setEnabled(True)
                self.user = layer.split("user='")[1].split("' ",1)[0]
                self.password = layer.split("password='")[1].split("' ",1)[0]
                self.dbname = layer.split("dbname='")[1].split("' ",1)[0]
                self.host = layer.split("host=")[1].split(" ",1)[0]
                self.port = layer.split("port=")[1].split(" ",1)[0]
                # self.paramFormulaire()
            else:
                self.actions[0].setEnabled(False)
        else:
            self.actions[0].setEnabled(False)



    # noinspection PyMethodMayBeStatic
    def tr(self, message):
        """Get the translation for a string using Qt translation API.

        We implement this ourselves since we do not inherit QObject.

        :param message: String for translation.
        :type message: str, QString

        :returns: Translated version of message.
        :rtype: QString
        """
        # noinspection PyTypeChecker,PyArgumentList,PyCallByClass
        return QCoreApplication.translate('travaux', message)


    def add_action(
        self,
        icon_path,
        text,
        callback,
        enabled_flag=False,
        add_to_menu=True,
        add_to_toolbar=True,
        status_tip=None,
        whats_this=None,
        parent=None):
        """Add a toolbar icon to the toolbar.

        :param icon_path: Path to the icon for this action. Can be a resource
            path (e.g. ':/plugins/foo/bar.png') or a normal file system path.
        :type icon_path: str

        :param text: Text that should be shown in menu items for this action.
        :type text: str

        :param callback: Function to be called when the action is triggered.
        :type callback: function

        :param enabled_flag: A flag indicating if the action should be enabled
            by default. Defaults to True.
        :type enabled_flag: bool

        :param add_to_menu: Flag indicating whether the action should also
            be added to the menu. Defaults to True.
        :type add_to_menu: bool

        :param add_to_toolbar: Flag indicating whether the action should also
            be added to the toolbar. Defaults to True.
        :type add_to_toolbar: bool

        :param status_tip: Optional text to show in a popup when mouse pointer
            hovers over the action.
        :type status_tip: str

        :param parent: Parent widget for the new action. Defaults None.
        :type parent: QWidget

        :param whats_this: Optional text to show in the status bar when the
            mouse pointer hovers over the action.

        :returns: The action that was created. Note that the action is also
            added to self.actions list.
        :rtype: QAction
        """

        icon = QIcon(icon_path)
        action = QAction(icon, text, parent)
        action.triggered.connect(callback)
        action.setEnabled(enabled_flag)

        if status_tip is not None:
            action.setStatusTip(status_tip)

        if whats_this is not None:
            action.setWhatsThis(whats_this)

        if add_to_toolbar:
            # Adds plugin icon to Plugins toolbar
            self.iface.addToolBarIcon(action)

        if add_to_menu:
            self.iface.addPluginToMenu(
                self.menu,
                action)

        self.actions.append(action)

        return action

    def initGui(self):
        """Create the menu entries and toolbar icons inside the QGIS GUI."""
        # global icon_path
        icon_path = ':/plugins/travaux/icon.png'

        cr = self.iface.layerTreeView().currentLayer()
        if cr:
            lay = cr.dataProvider().dataSourceUri(True).replace('"', '')
            if ('bd-cen-38' in lay)&('table=travaux.cr' in lay):
                flag = True
                self.user = lay.split("user='")[1].split("' ",1)[0]
                self.password = lay.split("password='")[1].split("' ",1)[0]
                self.dbname = lay.split("dbname='")[1].split("' ",1)[0]
                self.host = lay.split("host=")[1].split(" ",1)[0]
                self.port = lay.split("port=")[1].split(" ",1)[0]
            else:
                flag = False
        else:
            flag = False
        
        self.add_action(
            icon_path,
            text=self.tr(u'Travaux'),
            callback=self.run,
            enabled_flag=flag,
            parent=self.iface.mainWindow())

        self.first_start = True


    def unload(self):
        """Removes the plugin menu item and icon from QGIS GUI."""
        for action in self.actions:
            self.iface.removePluginMenu(
                self.tr(u'&travaux'),
                action)
            self.iface.removeToolBarIcon(action)


    def run(self):
        """Run method that performs all the real work"""

        # Create the dialog with elements (after translation) and keep reference
        # Only create GUI ONCE in callback, so that it will only load when the plugin is started
        self.con = psycopg2.connect("host={h} port={p} dbname={d} user={u} password={pwd}".format(
            h=self.host,p=self.port,d=self.dbname,u=self.user,pwd=self.password
        ))

        self.get_dict(self.con)
        # Check la sélection d'une géométrie
        if self.checkEvent():
            self.feature()

            if self.first_start == True:
                self.first_start = False
                self.dlg = travauxDialog()
                self.dlg.InitFormulaire(self.con)
            
            self.paramFormulaire()
            self.dlg.pre_gestion.currentIndexChanged.connect(self.eventGestion)

            # show the dialog
            self.dlg.show()
            self.dlg.pre_gestion.currentIndexChanged.connect(self.eventGestion)
            # Run the dialog event loop
            result = self.dlg.exec_()
            # self.dlg.pre_gestion.currentTextChanged.connect(self.eventGestion)
            # self.dlg.pre_gestion.activated[int].connect(self.eventGestion)
            # See if OK was pressed
            if result:
                # Do something useful here - delete the line containing pass and
                # substitute with your code.
                self.saveFormulaire()
            # pass


    def checkEvent(self):
        feat  = self.activeCouche.selectedFeatures()
        # edit  = self.activeCouche.isEditable()
        event = False
        if (len(feat) == 0) : #& edit:
            QMessageBox.warning(None, "Oups:", 'Selectionnez une géométrie')
        elif (len(feat) > 1) : #& edit: 
            QMessageBox.warning(None, "Oups:", 'Selectionnez UNE SEULE géométrie')
        elif (len(feat) == 1) : #& edit:
            event = True
        else:
            QMessageBox.warning(None, "Oups:", "La couche n'est pas en mode édition")

        return event


    def eventGestion(self):
        if self.dlg.pre_gestion.currentText():

            val = self.dlg.pre_gestion.currentText().split(' - ')[0]
            l = len(val)
            value = {k: v for k, v in self.dictData['res_gest'].items() if v[:l] == val}
            self.dlg.id_gestion.clear()
            self.dlg.id_gestion.addItems([None,*value.values()])
            if self.activeValues['id_gestion'] in value.keys():
                value = self.dictData['res_gest'][self.activeValues['id_gestion']]
                d1 = self.dlg.id_gestion.findText(value)
                self.dlg.id_gestion.setCurrentIndex(d1)
            self.dlg.id_gestion.setEnabled(True)
        else:
            self.dlg.id_gestion.clear()
            self.dlg.id_gestion.setEnabled(False)
            self.dlg.pre_gestion.setCurrentIndex(0)


    def feature(self):
        """Check la sélection d'une géométrie"""
        feat  = self.iface.activeLayer().selectedFeatures()

        fields = self.iface.activeLayer().fields().names()
        self.activeValues = {f:feat[0].attribute(f) for f in fields}
        
        # Mise en condition de la date_debut
        if self.activeValues['date_debut']:
            if self.activeValues['date_debut']=='':
                self.activeValues['date_debut'] = None

        # Complétion automatique des champs en fonction du type de géométrie
        if self.iface.activeLayer().geometryType()==QgsWkbTypes.PolygonGeometry:
            self.activeValues['surf_ha'] = round(feat[0].geometry().area()/10000,3)
            self.activeValues['surf_m2'] = round(feat[0].geometry().area(),3)
        elif self.iface.activeLayer().geometryType()==QgsWkbTypes.LineGeometry:
            self.activeValues['long_m'] = round(feat[0].geometry().length(),3)


    def paramFormulaire(self):
        self.dlg.label_21.setText(self.iface.activeLayer().name())

        if self.activeValues['id_site']:
            self.dlg.id_site.setText(self.activeValues['id_site'])
        else:self.dlg.id_site.clear()

        if self.activeValues['id_gestion']:
            val = self.dlg.pre_gestion.currentText().split(' - ')[0]
            l = len(val)
            dicValue = {k: v for k, v in self.dictData['res_gest'].items() if v[:l] == val}
            self.dlg.id_gestion.clear()
            self.dlg.id_gestion.addItems([None,*dicValue.values()])

            value = self.dictData['res_gest'][self.activeValues['id_gestion']]
            prevalue = self.dictData['res_pregest'][value[0]]
            prevaluekey = [v for v in self.dictData['res_pregest'] if self.dictData['res_pregest'][v] == prevalue][0]
            preval = prevaluekey + ' - ' +prevalue if prevaluekey is not None else prevalue
            d1 = self.dlg.id_gestion.findText(value)
            d2 = self.dlg.pre_gestion.findText(preval)
            self.dlg.pre_gestion.setCurrentIndex(d2)
            self.dlg.id_gestion.setCurrentIndex(d1)
        else:
            self.dlg.id_gestion.clear()
            self.dlg.id_gestion.setEnabled(False)
            self.dlg.pre_gestion.setCurrentIndex(0)

        if self.activeValues['id_presta']:
            d2 = self.dlg.id_presta.findText(self.dictData['res_prestataire'][self.activeValues['id_presta']])
            self.dlg.id_presta.setCurrentIndex(d2)
        else : self.dlg.id_presta.setCurrentIndex(0)

        if self.activeValues['prestation']:
            self.activeValues['prestation'] = int(self.activeValues['prestation'])
            d3 = self.dlg.prestation.findText(self.dictData['res_prestation'][self.activeValues['prestation']])
            self.dlg.prestation.setCurrentIndex(d3)
        else : self.dlg.prestation.setCurrentIndex(0)

        if self.activeValues['nom_presta']:
            self.dlg.nom_presta.setText(str(self.activeValues['nom_presta']))

        if self.activeValues['annee_trav']:
            self.dlg.annee_trav.setDate(dt.strptime(str(self.activeValues['annee_trav']),'%Y'))
        
        if self.activeValues['date_debut']:
            # self.dlg.date_debut.setDate(dt.strptime(str(self.activeValues['date_debut']),r'%Y-%m-%d'))
            self.dlg.date_debut.setDate(self.activeValues['date_debut'])
        
        if self.activeValues['duree_trav']:
            self.dlg.duree_trav.setText(str(self.activeValues['duree_trav']))
        
        if self.activeValues['crea_date']:
            self.dlg.crea_date.setText(self.activeValues['crea_date'].toString('dd-MM-yyyy'))
        
        if self.activeValues['date_update']:
            self.dlg.date_update.setText(self.activeValues['date_update'].toString('dd-MM-yyyy'))
        
        if self.activeValues['etat_trav']:
            if self.activeValues['etat_trav'] in ['Réalisé','true']:
                self.dlg.etat_trav.setChecked(True)
            elif self.activeValues['etat_trav'] in ['Prévisionnel','false']:
                self.dlg.etat_trav.setChecked(False)
            else:
                self.dlg.etat_trav.setChecked(self.activeValues['etat_trav'])
        
        if self.activeValues['nb_etp']:
            nb_etp = str(self.activeValues['nb_etp'])
            self.dlg.nb_etp.setText(nb_etp)
        else : self.dlg.nb_etp.clear()
        
        if self.activeValues['nb_balle']:
            nb_balle = str(self.activeValues['nb_balle'])
            self.dlg.nb_balle.setText(nb_balle)
        else : self.dlg.nb_balle.clear()
        
        if self.activeValues['val_mat']:
            self.activeValues['val_mat'] = int(self.activeValues['val_mat'])
            d4 = self.dlg.val_mat.findText(self.dictData['res_valmat'][self.activeValues['val_mat']])
            self.dlg.val_mat.setCurrentIndex(d4)
        else : self.dlg.val_mat.setCurrentIndex(0)
        
        if self.activeValues['legende']:
            self.dlg.legende.setText(self.activeValues['legende'])
        else : self.dlg.legende.clear()
        
        if self.activeValues['rmq']:
            # self.dlg.rmq.insertPlainText(self.activeValues['rmq'])
            self.dlg.rmq.setPlainText(self.activeValues['rmq'])
        else : self.dlg.rmq.clear()

        if self.iface.activeLayer().geometryType()==QgsWkbTypes.PolygonGeometry:
            self.dlg.surf_ha.setText(str(self.activeValues['surf_ha']))
            self.dlg.surf_m2.setText(str(self.activeValues['surf_m2']))
            self.dlg.long_m.setText(None)
        elif self.iface.activeLayer().geometryType()==QgsWkbTypes.LineGeometry:
            self.dlg.long_m.setText(str(self.activeValues['long_m']))
            self.dlg.surf_ha.setText(None)
            self.dlg.surf_m2.setText(None)


    def get_dict(self, con):
        # GET site_code
        rq_site = "SELECT DISTINCT ON (code_site) id,code_site FROM sites.c_sites_zonages ORDER BY code_site;"
        cur = con.cursor()
        cur.execute(rq_site)
        res_site = cur.fetchall()
        res_site = dict(res_site)

        rq_pregest = "SELECT DISTINCT code_n1,niveau1 FROM ref_travaux.cr_type_gestion ORDER BY 1"
        cur = con.cursor()
        cur.execute(rq_pregest)
        res_pregest = cur.fetchall()
        res_pregest = dict(res_pregest)
        lst_pregest = [i + ' - ' + res_pregest[i] if i is not None else res_pregest[i] for i in res_pregest]

        rq_gest = "SELECT id_gestion,legende FROM ref_travaux.cr_type_gestion ORDER BY 2"
        cur = con.cursor()
        cur.execute(rq_gest)
        res_gest = cur.fetchall()
        res_gest = dict(res_gest)

        rq_prestataire = "SELECT id_presta,lib_presta FROM ref_travaux.cr_type_prestataire ORDER BY 1"
        cur = con.cursor()
        cur.execute(rq_prestataire)
        res_prestataire = cur.fetchall()
        res_prestataire = dict(res_prestataire)

        rq_prestation = "SELECT id, val_mat FROM ref_travaux.cr_type_prestation ORDER BY 1"
        cur = con.cursor()
        cur.execute(rq_prestation)
        res_prestation = cur.fetchall()
        res_prestation = dict(res_prestation)

        rq_valmat = "SELECT id, val_mat FROM ref_travaux.cr_valorisation_matiere ORDER BY 1"
        cur = con.cursor()
        cur.execute(rq_valmat)
        res_valmat = cur.fetchall()
        res_valmat = dict(res_valmat)
        self.dictData = {
            'res_site':res_site,
            'res_gest':res_gest,
            'res_pregest':res_pregest,
            'res_prestataire':res_prestataire,
            'res_prestation':res_prestation,
            'res_valmat':res_valmat
        }


    def saveFormulaire(self):

        dic_colInverse = {self.iface.activeLayer().fields().names()[i]:i for i in self.iface.activeLayer().attributeList() if self.iface.activeLayer().fields().names()[i] != 'gid'}
        dic_col = {i: self.iface.activeLayer().fields().names()[i] for i in self.iface.activeLayer().attributeList() if self.iface.activeLayer().fields().names()[i] != 'gid'}
        
        gestion = self.dlg.id_gestion.currentText()
        presta = self.dlg.id_presta.currentText()
        prestation = self.dlg.prestation.currentText()
        val_mat = self.dlg.val_mat.currentText()
        id_gestion = [v for v in self.dictData['res_gest'] if self.dictData['res_gest'][v] == gestion]
        id_presta = [v for v in self.dictData['res_prestataire'] if self.dictData['res_prestataire'][v] == presta]
        id_prestation = [v for v in self.dictData['res_prestation'] if self.dictData['res_prestation'][v] == prestation]
        id_val_mat = [v for v in self.dictData['res_valmat'] if self.dictData['res_valmat'][v] == val_mat]
        id_gestion = int(id_gestion[0]) if id_gestion else None
        id_presta = int(id_presta[0]) if id_presta else None
        id_prestation = int(id_prestation[0]) if id_prestation else None
        id_val_mat = int(id_val_mat[0]) if id_val_mat else None

        attr_value={
            # dic_colInverse['id_site'] : self.dlg.id_site.text(),
            dic_colInverse['id_gestion'] : id_gestion,
            dic_colInverse['id_presta'] : id_presta,
            dic_colInverse['prestation'] : id_prestation,
            dic_colInverse['nom_presta'] : self.dlg.nom_presta.text() if self.dlg.nom_presta.text() else None,
            dic_colInverse['annee_trav'] : self.dlg.annee_trav.date().year(),
            dic_colInverse['date_debut'] : self.dlg.date_debut.date().toString('yyyy-MM-dd'),
            dic_colInverse['duree_trav'] : self.dlg.duree_trav.text() if self.dlg.duree_trav.text() else None,
            # dic_colInverse['crea_date'] : dt.now().date().isoformat(),
            # dic_colInverse['date_update'] : dt.now().date().isoformat(),
            dic_colInverse['etat_trav'] : 'Réalisé' if self.dlg.etat_trav.isChecked() else 'Prévisionnel',
            dic_colInverse['nb_etp'] : self.dlg.nb_etp.text() if self.dlg.nb_etp.text() else None,
            dic_colInverse['nb_balle'] : self.dlg.nb_balle.text() if self.dlg.nb_balle.text() else None,
            dic_colInverse['val_mat'] : id_val_mat,
            dic_colInverse['legende'] : self.dlg.legende.text() if self.dlg.legende.text() else None,
            dic_colInverse['rmq'] : self.dlg.rmq.toPlainText() if self.dlg.rmq.toPlainText() else None,
        }

        self.iface.activeLayer().startEditing()
        layer_provider = self.iface.activeLayer().dataProvider()
        id = self.iface.activeLayer().selectedFeatures()[0].id()
        layer_provider.changeAttributeValues({id:attr_value})
        self.iface.activeLayer().commitChanges()
        # self.iface.mapCanvas().refresh()

        # feat = self.activeCouche.selectedFeatures()
        # if self.dlg.id_site.text():
        #     feat[0]['id_site'] = self.dlg.id_site.text()
        # feat[0]['id_gestion'] = self.dlg.id_gestion.currentText()
        # feat[0]['id_presta'] = self.dlg.id_presta.currentText()
        # feat[0]['prestation'] = self.dlg.prestation.currentText()
        # feat[0]['nom_presta'] = self.dlg.nom_presta.text()
        # feat[0]['annee_trav'] = self.dlg.annee_trav.date().year()
        # feat[0]['date_debut'] = self.dlg.date_debut.date().toString('yyyy-MM-dd')
        # feat[0]['duree_trav'] = self.dlg.duree_trav.text()
        # if self.dlg.crea_date.text() == '':
        #     feat[0]['crea_date'] = dt.now().date().isoformat()
        # # date_update = self.dlg.date_update.date()
        # feat[0]['date_update'] = dt.now().date().isoformat()
        # feat[0]['etat_trav'] = self.dlg.etat_trav.isChecked()
        # feat[0]['nb_etp'] = self.dlg.nb_etp.text()
        # feat[0]['nb_balle'] = self.dlg.nb_balle.text()
        # feat[0]['val_mat'] = self.dlg.val_mat.currentText()
        # feat[0]['legende'] = self.dlg.legende.text()
        # feat[0]['rmq'] = self.dlg.rmq.toPlainText()
        ## Réalisé par une fonction postgresql

        # if self.iface.activeLayer().geometryType()==QgsWkbTypes.PolygonGeometry:
        #     feat[0]['surf_ha'] = float(self.dlg.surf_ha.text())
        #     feat[0]['surf_m2'] = float(self.dlg.surf_m2.text())
        # elif self.iface.activeLayer().geometryType()==QgsWkbTypes.LineGeometry:
        #     feat[0]['long_m'] = float(self.dlg.long_m.text())
        
        # self.canvas.refresh()
        # iface.activeLayer().startEditing()
        # dic_colInverse = {self.iface.activeLayer().fields().names()[i]:i for i in self.iface.activeLayer().attributeList() if self.iface.activeLayer().fields().names()[i] != 'gid'}
        # dic_col = {i: self.iface.activeLayer().fields().names()[i] for i in self.iface.activeLayer().attributeList() if self.iface.activeLayer().fields().names()[i] != 'gid'}
        # layer_provider=iface.activeLayer().dataProvider()
        # id = iface.activeLayer().selectedFeatures()[0].id()
        # attr_value={14:1090.398546}
        # attr_value={14:2556}
        # attr_value={14:'2556'}
        # attr_value={12:'tutu'}
        # attr_value={12:None}
        # attr_value={12:'tutu',14:2556}

        # layer_provider.changeAttributeValues({id:attr_value})

        # iface.activeLayer().selectedFeatures()[0]['long_m'] = 222
        # iface.activeLayer().selectedFeatures()[0]['rmq'] = None
        # iface.activeLayer().selectedFeatures()[0].setAttribute('long_m','1090.398546')
        # iface.activeLayer().selectedFeatures()[0].setAttribute(14,1090.398546)

        # iface.activeLayer().updateFields()

        # iface.activeLayer().updateFeature(iface.activeLayer().selectedFeatures()[0])
        # iface.activeLayer().commitChanges()
